package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionAccessInfo_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionAccessInfo extends JNIObject  {
	
	/* @generated */
	protected ISLUnionAccessInfo(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionAccessInfo_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionAccessInfo build(long ptr) {
		return new ISLUnionAccessInfo(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionAccessInfo_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_access_info_from_sink 
	 * 
	@take sink
	 * @generated
	**/
	 public static ISLUnionAccessInfo buildFromSink(ISLUnionMap sink) { 
		/*** PROTECTED REGION ID(static_isl_union_access_info_from_sink) DISABLED START ***/
		ISLUnionAccessInfo res;
		
		synchronized(LOCK) {
			checkParameters(sink);
			try {
				res = ISLUnionAccessInfo.build(ISLNative.isl_union_access_info_from_sink(getNativePtr(sink)));
			} finally {
				taken(sink);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLUnionAccessInfo access, int format) { 
		/*** PROTECTED REGION ID(static_isl_union_access_info_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_access_info_to_string(getNativePtr(access), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_access_info_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_access_info_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_access_info_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_copy 
	 * 
	 * @generated
	**/
	public ISLUnionAccessInfo copy() {
		/*** PROTECTED REGION ID(isl_union_access_info_copy) DISABLED START ***/
		ISLUnionAccessInfo res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionAccessInfo.build(ISLNative.isl_union_access_info_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_access_info_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_access_info_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_compute_flow 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionFlow computeFlow() {
		/*** PROTECTED REGION ID(isl_union_access_info_compute_flow) DISABLED START ***/
		ISLUnionFlow res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionFlow.build(ISLNative.isl_union_access_info_compute_flow(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_set_kill 
	 * 
	 * @take this kill
	 * @generated
	**/
	public ISLUnionAccessInfo setKill(ISLUnionMap kill) {
		/*** PROTECTED REGION ID(isl_union_access_info_set_kill) DISABLED START ***/
		ISLUnionAccessInfo res;
		
		synchronized(LOCK) {
			checkParameters(this, kill);
			try {
				res = ISLUnionAccessInfo.build(ISLNative.isl_union_access_info_set_kill(getNativePtr(this), getNativePtr(kill)));
			} finally {
				taken(this);
				taken(kill);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_set_may_source 
	 * 
	 * @take this may_source
	 * @generated
	**/
	public ISLUnionAccessInfo setMaySource(ISLUnionMap may_source) {
		/*** PROTECTED REGION ID(isl_union_access_info_set_may_source) DISABLED START ***/
		ISLUnionAccessInfo res;
		
		synchronized(LOCK) {
			checkParameters(this, may_source);
			try {
				res = ISLUnionAccessInfo.build(ISLNative.isl_union_access_info_set_may_source(getNativePtr(this), getNativePtr(may_source)));
			} finally {
				taken(this);
				taken(may_source);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_set_must_source 
	 * 
	 * @take this must_source
	 * @generated
	**/
	public ISLUnionAccessInfo setMustSource(ISLUnionMap must_source) {
		/*** PROTECTED REGION ID(isl_union_access_info_set_must_source) DISABLED START ***/
		ISLUnionAccessInfo res;
		
		synchronized(LOCK) {
			checkParameters(this, must_source);
			try {
				res = ISLUnionAccessInfo.build(ISLNative.isl_union_access_info_set_must_source(getNativePtr(this), getNativePtr(must_source)));
			} finally {
				taken(this);
				taken(must_source);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_set_schedule 
	 * 
	 * @take this schedule
	 * @generated
	**/
	public ISLUnionAccessInfo setSchedule(ISLSchedule schedule) {
		/*** PROTECTED REGION ID(isl_union_access_info_set_schedule) DISABLED START ***/
		ISLUnionAccessInfo res;
		
		synchronized(LOCK) {
			checkParameters(this, schedule);
			try {
				res = ISLUnionAccessInfo.build(ISLNative.isl_union_access_info_set_schedule(getNativePtr(this), getNativePtr(schedule)));
			} finally {
				taken(this);
				taken(schedule);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_access_info_set_schedule_map 
	 * 
	 * @take this schedule_map
	 * @generated
	**/
	public ISLUnionAccessInfo setScheduleMap(ISLUnionMap schedule_map) {
		/*** PROTECTED REGION ID(isl_union_access_info_set_schedule_map) DISABLED START ***/
		ISLUnionAccessInfo res;
		
		synchronized(LOCK) {
			checkParameters(this, schedule_map);
			try {
				res = ISLUnionAccessInfo.build(ISLNative.isl_union_access_info_set_schedule_map(getNativePtr(this), getNativePtr(schedule_map)));
			} finally {
				taken(this);
				taken(schedule_map);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionAccessInfo_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
